unit DaemonUnit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, DaemonApp; 

type

  { TTestThread }

  TTestThread  =  Class(TThread)
  Procedure  Execute;  override;
end;


type

  { TDaemon1 }

  TDaemon1 = class(TDaemon)
  private
     FThread  :  TTestThread;
     Procedure  ThreadStopped  (Sender  :  TObject);
    { private declarations }
  public
    { public declarations }
    Function  Install  :  Boolean;  override;
    Function  UnInstall  :  Boolean;  override;
    Function  Start  :  Boolean;  override;
    Function  Stop  :  Boolean;  override;
    Function  Pause  :  Boolean;  override;
    Function  Continue  :  Boolean;  override;
    Function  ShutDown  :  Boolean;  override;
    Function  Execute  :  Boolean;  override;
  end; 

var Daemon1: TDaemon1;

procedure AWriteln(cText : string; lOk : boolean);



implementation

procedure AWriteln( cText: string; lOk: boolean);
var cTemp : string;
begin
   if lOk then
      cTemp := 'Ok'
   else
      cTemp := 'Fehler';
   Application.Log(etInfo, cText + cTemp);
end;

Procedure RegisterDaemon; 
begin
  RegisterDaemonClass(TDaemon1);
end;

{ TDaemon1 }

procedure TDaemon1.ThreadStopped(Sender: TObject);
begin

end;

function TDaemon1.Install: Boolean;
begin
  Result:=inherited Install;
  AWriteln('Daemon  Install:  ',Result);
end;

function TDaemon1.UnInstall: Boolean;
begin
  Result:=inherited UnInstall;
  AWriteln('Daemon  UnInstall:  ',Result);
end;

function TDaemon1.Start: Boolean;
begin
   Result:=inherited Start;
   AWriteln('Daemon  Start  ',Result);
   FThread:=TTestThread.Create(True);
   FThread.OnTerminate:=@ThreadStopped;
   FThread.FreeOnTerminate:=False;
end;

function TDaemon1.Stop: Boolean;
begin
  Result:=inherited Stop;
  AWriteln('Daemon  Stop:  ',Result);
end;

function TDaemon1.Pause: Boolean;
begin
  Result:=inherited Pause;
  AWriteln('Daemon  Pause:  ',Result);
end;

function TDaemon1.Continue: Boolean;
begin
  Result:=inherited Continue;
  AWriteln('Daemon  Continue:  ',Result);
end;

function TDaemon1.ShutDown: Boolean;
begin
  Result:=inherited ShutDown;
  AWriteln('Daemon  ShutDown:  ',Result);
end;

function TDaemon1.Execute: Boolean;
begin
  Result:=inherited Execute;
  AWriteln('Daemon  Execute:  ',Result);
end;

{ TTestThread }

procedure TTestThread.Execute;
Var C  :  Integer;
begin
 //  inherited Execute;
   C:=0;
   Repeat
      Sleep(1000);
      inc(c);
      Application.Log(etInfo, Format('Tick  :  %d',[C]));
   Until  Terminated;
end;

{$R *.lfm}


initialization
  RegisterDaemon; 
end.

